//Ksztette:    Berezvai Dniel
//Dtum:         2012.03.28.
//EHA kd:       BEDTACI.ELTE
//e-mail:        3ice@3ice.hu
//Csoport:       11.csoport
//Feladat:       2.beadand/11.feladat
//               rumozgsok

/* Adott kt szekvencilis input fjl. Az egyikben egy raktr kszletnek nyilvntartsa (ruazonost, mennyisg) prok formjban, a msikban az aznapi rumozgsok adatai (ruazonost, mennyisg) prokkal (A mennyisg negatv, ha kivittk az rut, pozitv, ha behoztk). Mindkt fjl ruazonost szerint rendezett, a raktrkszlet azonost szerint egyrtelm is. A mozgsok kztt csak olyan ru szerepel, aki benne van a nyilvntartsban. Mdostsuk a raktrnyilvntartst s adjunk hibajelzst, ha a raktrkszlet negatv lesz. */

#include <iostream>
#include "enor.h"

using namespace std;

int main(int argc, char *argv[]){
	setlocale(LC_ALL,"Hun");

	string tnev;
	string mnev;

	if(argc>2){//Van 2 paramter
		tnev=argv[1];
		mnev=argv[2];
	}else{//Nincs kt paramter
		cout<<"Nincs elg paramter!\n";
		if(argc>1){//De van 1
			cout<<"Add meg a mdostfjl nevt: ";
			cin>>mnev;
		}else{//1 paramter sincs.
			cout<<"Add meg a raktrkszlet nevt: ";
			cin>>tnev;
			cout<<"Add meg a mdostfjl nevt: ";
			cin>>mnev;
		}
	}

	beRaktar t(tnev);
	beRaktar m(mnev);

	St st,sm;
	Dt dt,dm;

	t.Read(dt,st);
	m.Read(dm,sm);
	kiRaktar u("ujraktarkeszlet.txt");
	int egyezesek=0;int hibak=0;int torzselorebb=0;int modelorebb=0;int maradek=0;

	while(st==norm || sm==norm){

//Egyezst talltunk. Kiszmoljuk az j darabszmot s olvassuk mindkt fjlt.
		if(sm==norm && st==norm && dt.azon==dm.azon){
			egyezesek++;
			Dt ujdt;
			ujdt.azon=dt.azon;
			ujdt.db=dt.db+dm.db;
			u.Write(ujdt);
			t.Read(dt,st);
			m.Read(dm,sm);

//Ha negatv a raktrkszlet, jelezzk, de megynk tovbb.
			if(ujdt.db<0){
				hibak++;
				cout<<"Hiba trtnt! Negatv a raktrkszlet: "<<ujdt.azon<<" ("<<ujdt.db<<" db)\n";
			}

//A trzsfjl elrbb van. Olvassuk a mdostfjlt.
		}else if(st==norm && sm==norm && dt.azon>dm.azon){
			torzselorebb++;
			m.Read(dm,sm);

//A mdostfjl elrbb van. Kirjuk a vltozatlan sort, majd olvassuk a trzsfjlt.
		}else if(st==norm && sm==norm && dt.azon<dm.azon){
			modelorebb++;
			u.Write(dt);
			t.Read(dt,st);

//Elfogyott a mdostfjl, mg kirjuk a trzsfjl maradk rszt.
		}else if(st==norm && sm==abnorm){
			maradek++;
			u.Write(dt);
			t.Read(dt,st);
		}
	}

	cout<<"A futs sorn "<<egyezesek<<" darab egyezst talltam s "<<hibak<<" darab hiba trtnt. "<<modelorebb+egyezesek+maradek<<" adatsort dolgoztam fel sszesen.\n";
	return 0;
}
